/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *
 *  Copyright (C) 2010 by Meika Sugimoto
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 */

#include <vector>
#include <map>
#include <algorithm>
#include <functional>

#include "toppers/global.hpp"
#include "toppers/oil/configuration_manager.hpp"

using namespace std;
using namespace toppers::oil;
using namespace toppers::oil::oil_implementation;
using namespace toppers::oil::oil_definition;

namespace toppers
{
	namespace configuration_manager
	{
		// APPMODETt@N^
		bool find_appmode_object(object_definition *p)
		{
			if(p->get_object_type() == "APPMODE")
			{
				return true;
			}
			return false;
		}

		bool config_manage::read_configuration
			(toppers::text *txt , std::vector<std::string> const& objlist)
		{
			  description = txt;

			  // XgO
			  description_str = new string();
			  typedef text::container::const_iterator const_row_iterator;
			  typedef std::string::size_type size_type;
			  const_row_iterator first( txt->begin().get_row() ), last( txt->end().get_row() );

			  for ( const_row_iterator iter( first ); iter != last; ++iter )
			  {
				  *description_str += iter->buf;
			  }

			  // p[T̐
			  try
			  {
				  parser = new ::oil_parser(description_str , objlist);
			  }
			  catch( ... )
			  {
				  toppers::fatal("Memory allocation error.");
			  }

			if(parser->do_parse(&oil_impl , &oil_def) == 0)
			{
				std::string kernel_type;
				// APPMODE`ĂȂOSDEFAULTAPPMODE}
				toppers::get_global("kernel" , kernel_type);
				if((kernel_type == "atk1")
					&& (oil_def->end() == 
						(find_if(oil_def->begin() , oil_def->end() , find_appmode_object))))
				{
					oil_def->push_back(new object_definition("APPMODE OSDEFAULTAPPMODE"));
				}

				return true;
			}
			else
			{
				std::string message;
				int position;
				text::const_iterator iter;

				// G[ʒu̎擾
				parser->get_error(&position , &message);
				// Ys̎擾
				iter = description->line_at(position);
				text::line_type error_occur = iter.line();
				
				// @G[͂ɏI
				toppers::fatal(iter.line() , "%1%" , message);
				
				return false;
			}
		}

		bool object_matching(object_definition* obj , oil_object_impl* impl)
		{
			return impl->validate_object_configuration(obj , NULL);
		}

		bool config_manage::validate_and_assign_default_configuration(void)
		{
			bool result = true;
			std::vector<oil_definition::object_definition*>::iterator p;
			std::vector<oil_implementation::oil_object_impl*>::iterator q , found;
			
			// SẴIuWFNg`ƐĂ邩`FbNA
			// ftHgp[^̕⊮s
			for(p = oil_def->begin() ; p != oil_def->end() ; p++)
			{
				std::vector<toppers::oil::object_ref> object_refs;
				for(q = oil_impl->begin() ; q != oil_impl->end() ; q++)
				{
					if((*q)->validate_object_configuration(*p , &object_refs) == true)
					{
						break;
					}
				}
				
				if(q >= oil_impl->end())
				{
					// p[^̐`FbN
					result = false;
					break;
				}
				
				// t@X悪̃`FbN
				result = validate_object_reference((*p)->get_name() , &object_refs);
			}

			return result;
		}
		bool config_manage::validate_object_reference
				(std::string obj_name , std::vector<object_ref> *obj_refs)
		{
			std::vector<oil_definition::object_definition*>::iterator q;
			std::vector<object_ref>::iterator p;
			bool result = true;
			
			for(p = obj_refs->begin() ; p != obj_refs->end() ; p++)
			{
				std::vector<oil_definition::object_definition*> name_match;
				// ÔT
				for(q = oil_def->begin() ; q != oil_def->end() ; q++)
				{
					if((*p).obj_name == (*q)->get_name())
					{
						name_match.push_back(*q);
					}
				}
				// OvȂ΂̎_ŃG[
				if(name_match.empty() == true)
				{
					toppers::error("Object %1%'s parameter %2% reference %3% , but not found." ,
										obj_name , (*p).obj_type , (*p).obj_name);
					result = false;
					continue;
				}

				// QƐ̃^CvT
				for(q = name_match.begin() ; q != name_match.end() ; q++)
				{
					if((*p).obj_type == (*q)->get_object_type())
					{
						break;
					}
				}
				// ^Cv̂Ȃ΃G[
				if(q == name_match.end())
				{
					toppers::error("Object %1%'s parameter %2% reference %3% , but referenced object is not %4%_TYPE" , 
									obj_name , (*p).obj_type , (*p).obj_name , (*p).obj_type);
					result = false;
				}
			}

			return result;
		}

	}	/* namespace oil */

}	/* namespace toppers */

